/*
 * MBSet.h
 *
 *  Created on: Dec 25, 2010
 *      Author: Tobias Brosch
 */

#ifndef MBSET_H_
#define MBSET_H_

#include <QtGui>
#include <boost/multi_array.hpp>

class MBSet: public QObject {
Q_OBJECT
public:
	class MBSetParams {
	public:
		MBSetParams(int width, int height);

		void scr2World(double &x, double &y) const;
		double get_num_iter(double x_pos, double y_pos);

		int getWidth() const;
		int getHeight() const;
		double getCenterX() const;
		double getCenterY() const;
		double getScale() const;
		int getMaxIter() const;

	private:
		int _width;
		int _height;

		double _center_x;
		double _center_y;
		double _scale;
		int _maxIter;

		static const double DEF_CENTER_X = 0;
		static const double DEF_CENTER_Y = 0;
		static const double DEF_SCALE = 1. / 100;
		//		static const double DEF_CENTER_X = 0.357618;
		//		static const double DEF_CENTER_Y = -0.326124;
		//		static const double DEF_SCALE = 9.53674e-09;
	}; // class MBSetParams

public:
	MBSet(int width = 400, int height = 200, QObject* parent = 0);

	void updateModel();

signals:
void viewChanged(const boost::multi_array<double, 2>* mat);

private:

	MBSetParams _params;
	boost::multi_array<double, 2> _mat;


};

#endif /* MBSET_H_ */
