/*
 * MBViewer.cpp
 *
 *  Created on: Dec 24, 2010
 *      Author: Tobias Brosch
 */

#include "MBViewer.h"

MBViewer::MBViewer(QWidget *parent) :
	QLabel(parent) {

}

void MBViewer::updateView(const boost::multi_array<double, 2>* mat) {
	typedef boost::multi_array<double, 2>::size_type size_type;

	const size_type* dims = mat->shape();
	int width = dims[0];
	int height = dims[1];

	QImage image(width, height, QImage::Format_RGB32);
	// translate double values to colors
	for (int line = 0; line < height; ++line) {
		QRgb* pixels = reinterpret_cast<QRgb*> (image.scanLine(line));
		for (int pos = 0; pos < width; ++pos) {
			pixels[pos] = qRgb( 0, (*mat)[pos][line] * 255, 0);
		}
	}
	setPixmap(QPixmap::fromImage(image));
	adjustSize();
}


